Page MenuHomePhabricator

ios: Create overlay button doesn't capture clicks when keyboard open
Closed, ResolvedPublic

Description

Bad things happen if you start typing in create collection field and then hit "create"
see:

@ 8s


Solution for this card:

  • Replace ButtonWithSpinner in the collection content overlay with a normal button.
  • Disable the button while the collection is being created (instead of the spinner shown right now).

Event Timeline

JKatzWMF created this task.May 8 2015, 11:49 PM
JKatzWMF raised the priority of this task from to Needs Triage.
JKatzWMF updated the task description. (Show Details)
JKatzWMF added a project: Gather.
JKatzWMF moved this task to Needs triage on the Gather board.
JKatzWMF added a subscriber: JKatzWMF.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 8 2015, 11:49 PM
JKatzWMF moved this task from Needs triage to This Sprint on the Gather board.May 8 2015, 11:49 PM
JKatzWMF set Security to None.
Jdlrobson added a subscriber: Jdlrobson.

This bug is a bit unclear right now.
What time in the movie can we see this issue? The first click to create fails due to the tap area being too small I think...

perhaps, but I have this problem every single time.
The problem happens at 8 seconds.

So yeh that looks like a touch error problem - the click is not registering with the button so instead it is triggering a scroll. Should we make it bigger?

in theory, it should be the size of the button and no more. I am pretty
sure I am clicking on the button -- as I see it spin before it exits me out
of dialogue (but nothing else happens).
-J

The button is being created via oojs ui via ButtonWithSpinner in mobile web so it's very possible something is going wrong there - e.g. tap area too small.

Jdlrobson renamed this task from Create overlay button cannot be clicked while text window is open (in ios) to ios: Create overlay button doesn't capture clicks 1000% of time..May 13 2015, 3:38 PM
Jdlrobson removed JKatzWMF as the assignee of this task.
Jdlrobson updated the task description. (Show Details)
Jdlrobson updated the task description. (Show Details)
Jdlrobson updated the task description. (Show Details)
Jdlrobson moved this task from In Analysis to Ready for dev on the Gather Sprint Help! board.
Jdlrobson renamed this task from ios: Create overlay button doesn't capture clicks 1000% of time. to ios: Create overlay button doesn't capture clicks 100% of time..May 13 2015, 7:51 PM

Herp derp, kind of can't reproduce on the iphone 5s with the iOS simulator locally. Clicking the create button closes the keyboard, and you have to click it again but I'm not seeing the weirdness of the video.

I would try to confirm on beta labs but its dead.

I'll continue investigating

@bmansurov @phuedx the ButtonWithSpinner has problems in iOS (tapping it with the keyboard open removes focus from the keyboard but it doesn't actually tap the button). What do you guys think we should do? I can rewrite it as a normal view with the spinner if you guys are good with it (i'm guessing that would solve the problem).

@Jhernandez, the goal of the buttonWithSpinner module was to slowly start integrating oojs-ui into our codebase. I think we should fix the problem. I'd check with the oojs-ui team and see what they have to say.

@bmansurov as I've discussed with you before we are a long way from getting mobile moved over to oojs ui. The ButtonWithSpinner is problematic for multiple reasons (not compatible with our View code) - see T95490

Our path of least resistance "roadmap" for converting mobile web to oojs ui starts with T96202 not here.
@Jhernandez I'd suggest we rewrite this in Gather for the time being as a View since this is breaking a fundamental part of Gather's extension and we need to look to swat deploy this early next week (not to mention it blocks us pushing this to stable).
@bmansurov I'd appreciate it if you could look at this bug in oojs ui since you have more experience than most with it.

@bmansurov @Jdlrobson regardless of the long term solution, i just want to emphasize that the core functionality is broken for iOS users, so fixing this soon is important.

I'm not able to reproduce this on a simulator. Can someone with access to a device debug it? In the meantime it would be best if you guys use a regular button.

Jhernandez removed Jhernandez as the assignee of this task.May 27 2015, 1:23 PM
Jhernandez updated the task description. (Show Details)
JKatzWMF renamed this task from ios: Create overlay button doesn't capture clicks 100% of time. to ios: Create overlay button doesn't capture clicks.May 28 2015, 5:47 PM
JKatzWMF renamed this task from ios: Create overlay button doesn't capture clicks to ios: Create overlay button doesn't capture clicks when keyboard open.
JKatzWMF moved this task from This Sprint to Must haves on the Gather board.
JKatzWMF moved this task from Must haves to This Sprint on the Gather board.

Change 215002 had a related patch set uploaded (by Jhernandez):
Remove button with spinner to fix iOS tap not capturing

https://gerrit.wikimedia.org/r/215002

Tested on iPhone 5s iOS 8.2 on the iOS simulator and now tapping the create button both hides the keyboard and actually creates the collection.

We lost the spinner in the process though.

Ideally I'd like to see us still show the button with spinner. It seems like it would be trivial to do this without OOJS ui and we should. Having no feedback is also not good. @Jhernandez could you prepare a follow up to do that? I really don't think we win anything by stalling on upstreaming the bug right now. There are likely to be many more oojs ui bugs on ios and I'd rather we concentrated on all of them in one go e.g. rewriting the VisualEditorOverlay.

Change 215319 had a related patch set uploaded (by Jhernandez):
Use mw-ui button with spinner for the create collection button

https://gerrit.wikimedia.org/r/215319

@Jdlrobson ⬆️ There you go :)

Macro shits-on-fire:

Change 215002 merged by jenkins-bot:
Remove button with spinner to fix iOS tap not capturing

https://gerrit.wikimedia.org/r/215002

Change 215319 merged by jenkins-bot:
Use mw-ui button with spinner for the create collection button

https://gerrit.wikimedia.org/r/215319

JKatzWMF closed this task as Resolved.Jun 8 2015, 4:07 PM
Jdforrester-WMF moved this task from Backlog to Reviewing on the OOUI board.Jun 10 2015, 2:28 AM